Attribute VB_Name = "MExample02"
Private Declare Sub Sleep Lib "kernel32" (ByVal dw_msecs As Long)
Option Compare Text
Option Base 0

Public Sub Main()
    Dim bShowPrompt As Boolean: bShowPrompt = True

    EasyconInitialize
    
    On Error GoTo eh_unknown_error
    
    stdout.WriteBlankLines 1
    stdout.WriteLine "   ***********************************************"
    stdout.WriteLine "   * Simplistic Shell (writted on VB6)           *"
    stdout.WriteLine "   * Replacement for [cmd.exe] ;)                *"
    stdout.WriteLine "   ***********************************************"
    
    stdout.WriteBlankLines 2
    
    DisplayHelp
    
    Dim sCurrentCmdLine As String
    Dim sCurrentCmdLineParts() As String
    
    
    
    Do
        PrintPrompt bShowPrompt '  ,  c:\windows\>
        
        sCurrentCmdLine = stdin.ReadLine '     STDIN
        
        If Len(sCurrentCmdLine) = 0 Then sCurrentCmdLine = " "
        sCurrentCmdLineParts = Split(sCurrentCmdLine, " ", 2)
        
        
        Select Case sCurrentCmdLineParts(0)
            Case ""
                '   
            Case "echo"
                stdout.WriteLine sCurrentCmdLineParts(1)
            Case "helpme"
                DisplayHelp
            Case "bye"
                Exit Sub
            Case "msgbox"
                MsgBox sCurrentCmdLineParts(1)
            Case "cd"
                On Error GoTo eh_change_dir
                If sCurrentCmdLineParts(1) Like "[A-z]:\*" Then
                    ChDrive sCurrentCmdLineParts(1)
                End If
                ChDir sCurrentCmdLineParts(1)
            Case "mkdir"
                MkDir sCurrentCmdLineParts(1)
            Case "rmdir"
                RmDir sCurrentCmdLineParts(1)
            Case "dir"
                Dim sf As String
                sf = Dir(".")
                
                Do
                    stdout.WriteLine " |- " + sf + Space(20 - Len(sf)) + " SIZE: " + CStr(FileLen(sf))
                    sf = Dir()
                Loop Until Len(sf) = 0
                
                
            Case "prompt"
                Select Case sCurrentCmdLineParts(1)
                    Case "on"
                        bShowPrompt = True
                        stdout.WriteLine "Prompt will be displayed fully."
                    Case "off"
                        bShowPrompt = False
                        stdout.WriteLine "Prompt will be displayed in shorted form."
                    Case Else
                        stderr.Write "Error: invalid argument, only ON or OFF are allowed arguments!"
                End Select
            Case Else
                On Error GoTo eh_external_command:
                Shell sCurrentCmdLine
        End Select
    Loop
        
    Exit Sub
    
eh_change_dir:
    
    Resume Next
eh_external_command:
    stderr.WriteLine "Command execution error: " + Err.Description
    Err.Clear
    Resume Next
eh_unknown_error:
    stderr.WriteLine "Unexpected error: [" + CStr(Err.Number) + "] " + Err.Description
    Resume Next
End Sub

Private Sub DisplayHelp()
    stdout.WriteLine " List of supported commands:"
    stdout.WriteLine "  CD <path>          - Change Dir (same as usual)"
    stdout.WriteLine "  DIR                - Show content of current directory."
    stdout.WriteLine "  MKDIR <new_path>   - Make new directory."
    stdout.WriteLine "  RMDIR <path>       - Remove existing directory."
    stdout.WriteLine "  ECHO <text>        - Print <text> on this console."
    stdout.WriteLine "  MSGBOX <text>      - Show Message Box with <text>."
    stdout.WriteLine "  HELPME             - Show this help on commands."
    stdout.WriteLine "  BYE                - Terminate work of this Shell"
    stdout.WriteLine "  PROMPT {OFF|ON}    - Disables or enables displaying of prompt."
    stdout.WriteBlankLines 1
End Sub

Private Sub PrintPrompt(ByVal bFullPrompt As Boolean)
    If bFullPrompt Then stdout.Write CurDir$
    stdout.Write "> "
End Sub
